package org.netkernel.json.core.endpoint;

import org.json.JSONArray;
import org.json.JSONObject;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer1.representation.IDeterminateStringRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;

public class JSONParser extends StandardTransreptorImpl
{

	public JSONParser()
	{	this.declareThreadSafe();
		this.declareToRepresentation(JSONObject.class);
		this.declareToRepresentation(JSONArray.class);
	}

	@Override
	public void onTransrept(INKFRequestContext context) throws Exception
	{	IDeterminateStringRepresentation s=context.sourcePrimary(IDeterminateStringRepresentation.class);
		Class c=context.getThisRequest().getRepresentationClass();
		Object result=null;
		if(c.isAssignableFrom(JSONObject.class))
		{	result=new JSONObject(s.getString());
		}
		else
		{	result=new JSONArray(s.getString());
		}
		context.createResponseFrom(result);
	}
}
